Subject: bug#78222: package-vc-from-checkout generates incorrect package summaries

From: Philip Kaludercic <[email-masked]>
Date: Sat, 17 May 2025 09:03:47 +0000

JD Smith <[email-masked]> writes:

>> On May 16, 2025, at 11:29 AM, Philip Kaludercic <[email-masked]> wrote:
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>>>> From: JD Smith <[email-masked]>
>>>> Date: Fri, 2 May 2025 20:16:52 -0400
>>>> 
>>>> `package-vc-install-from-checkout' fails to generate correct package
>>>> summaries in the package files it generates, always using "No
>>>> description available."
>>>> 
>>>> The issue is as follows:
>>>> 
>>>>    • `package-vc-install-from-checkout' uses `package-desc-create'
>>>> to create a description structure based on the directory name of the
>>>> installed package.
>>>>    • This constructor includes a default `summary' slot of
>>>> `package--default-summary' ("No description available.")
>>>>    • During unpacking, `package-vc--generate-description-file' is
>>>> called with this pre-populated description structure.
>>>>    • It notices the existence of the (default)
>>>> `package-desc-summary', and simply skips reading the main package
>>>> file to derive the summary from its header line.
>>>> 
>>>> The solution may be to alter the test logic in
>>>> `package-vc--generate-description-file', or let-bind
>>>> `package--default-summary=nil' during structure creation.
>>> 
>> 
>> What version of Emacs are you on?  Ever since bug#76065 we are testing
>> if the description matches the default description, in which we add a
>> special case for re-checking the package description if the current
>> description matches `package--default-summary'.
>
> I'm on the Emacs-30 branch.  I don't see a version number in package-vc.el, but it lists:
>
> ;;; package-vc.el --- Manage packages from VC checkouts     -*- lexical-binding: t; -*-
> ;; Copyright (C) 2022-2025 Free Software Foundation, Inc.
>
> Last commit d63b27a416b.

That is enough information, the fix I mentioned was applied onto the
master branch.  Do you want to build the master branch yourself and
check if the bug has been resolved, or should we just close the bug
directly as a duplicate?